export declare function prepareMockAuth(): Promise<{
    appId: import("dbmage").Id;
    rando: {
        random: () => number;
        compare: (a: string, b: string) => boolean;
        randomId: () => import("dbmage").Id;
        randomBuffer: (bytes: number) => ArrayBuffer;
        randomSample: <T>(palette: T[]) => T;
        randomSequence: (length: number, palette: string[]) => string;
    };
    config: import("../../assembly/backend/types/secret-config.js").SecretConfig;
    storage: import("dbmage").FlexStorage;
    appOrigin: string;
    databaseRaw: import("../../assembly/backend/types/database.js").DatabaseRaw;
    authPolicies: {
        greenPolicy: import("renraku").Policy<undefined, import("../../features/auth/types/auth-metas.js").GreenAuth>;
        anonPolicy: import("renraku").Policy<import("../../features/auth/types/auth-metas.js").AnonMeta, import("../../features/auth/types/auth-metas.js").LoginAuth>;
        userPolicy: import("renraku").Policy<import("../../features/auth/types/auth-metas.js").UserMeta, import("../../features/auth/types/auth-metas.js").UserAuth>;
        platformUserPolicy: import("renraku").Policy<import("../../features/auth/types/auth-metas.js").PlatformUserMeta, import("../../features/auth/types/auth-metas.js").PlatformUserAuth>;
        appOwnerPolicy: import("renraku").Policy<import("../../features/auth/types/auth-metas.js").AppOwnerMeta, import("../../features/auth/types/auth-metas.js").AppOwnerAuth>;
    };
}>;
