import * as renraku from "renraku";
export function makePrivilegeChecker(permit, privileges) {
    function hasPrivilege(key) {
        return permit.privileges.includes(privileges[key]);
    }
    function requirePrivilege(key) {
        if (!hasPrivilege(key))
            throw new renraku.ApiError(403, `forbidden; privilege required "${key}"`);
    }
    function requireNotHavePrivilege(key) {
        if (hasPrivilege(key))
            throw new renraku.ApiError(403, `forbidden: must not have privilege "${key}"`);
    }
    return {
        hasPrivilege,
        requirePrivilege,
        requireNotHavePrivilege,
    };
}
//# sourceMappingURL=make-privilege-checker.js.map