import { Op } from "../../../../../framework/ops.js";
import { AccessPayload } from "../../../types/auth-tokens.js";
import { AccessModelOptions } from "./types/access-model-options.js";
export declare function makeAccessModel({ authMediator, loginService }: AccessModelOptions): {
    getAccessOp(): Op<AccessPayload>;
    getAccess(): AccessPayload;
    getValidAccess(): Promise<AccessPayload>;
    useExistingLogin(): Promise<void>;
    sendLoginLink(email: string): Promise<void>;
    login(loginToken: string): Promise<void>;
    logout(): Promise<void>;
    reauthorize(): Promise<void>;
    readable: {
        accessOp: Op<AccessPayload>;
    };
    track: <X>(observer: import("@chasemoskal/snapstate").Observer<{
        accessOp: Op<AccessPayload>;
    }, X>, reaction?: import("@chasemoskal/snapstate").Reaction<X>, options?: {
        flip?: boolean;
    }) => () => void;
    subscribe: (subscription: import("@chasemoskal/snapstate").Subscription<{
        accessOp: Op<AccessPayload>;
    }>) => () => void;
};
