import * as dbmage from "dbmage";
export declare type UserSchema = dbmage.AsSchema<{
    accounts: AccountRow;
    profiles: ProfileRow;
    emails: EmailRow;
    latestLogins: LatestLoginRow;
}>;
export declare type AccountRow = dbmage.AsRow<{
    userId: dbmage.Id;
    created: number;
}>;
export declare type ProfileRow = dbmage.AsRow<{
    userId: dbmage.Id;
    nickname: string;
    tagline: string;
    avatar: undefined | string;
}>;
export declare type EmailRow = dbmage.AsRow<{
    userId: dbmage.Id;
    email: string;
}>;
export declare type LatestLoginRow = dbmage.AsRow<{
    userId: dbmage.Id;
    time: number;
}>;
