import { ops } from "../../../framework/ops.js";
import { makeStoreState } from "./state/make-store-state.js";
import { makeStoreAllowance } from "./utils/make-store-allowance.js";
import { makeConnectSubmodel } from "./submodels/connect-submodel.js";
import { makeSubscriptionPlanningSubmodel } from "./submodels/subscription-planning-submodel.js";
export function makeStoreModel(options) {
    const state = makeStoreState();
    const allowance = makeStoreAllowance(state);
    const connectSubmodel = makeConnectSubmodel({ ...options, state, allowance });
    const subscriptionPlanningSubmodel = makeSubscriptionPlanningSubmodel({
        ...options, state, allowance,
    });
    return {
        state: state.readable,
        subscribe: state.subscribe,
        allowance,
        connectSubmodel,
        subscriptionPlanningSubmodel,
        async updateAccessOp(op) {
            state.writable.user.accessOp = op;
            state.writable.stripeConnect.connectStatusOp = ops.none();
            state.writable.stripeConnect.connectDetailsOp = ops.none();
            await Promise.all([
                connectSubmodel.refresh(),
            ]);
        },
    };
}
//# sourceMappingURL=store-model.js.map