import { Service } from "../../../../types/service.js";
import { makeStoreState } from "../state/make-store-state.js";
import { TriggerStripeConnectPopup } from "../../types/store-popups.js";
import { makeStoreAllowance } from "../utils/make-store-allowance.js";
import { makeConnectService } from "../../api/services/connect-service.js";
export declare function makeConnectSubmodel({ state, allowance, connectService, triggerStripeConnectPopup, }: {
    state: ReturnType<typeof makeStoreState>;
    allowance: ReturnType<typeof makeStoreAllowance>;
    connectService: Service<typeof makeConnectService>;
    triggerStripeConnectPopup: TriggerStripeConnectPopup;
}): {
    activate: () => Promise<void>;
    refresh: () => Promise<void>;
    onChange: (...listeners: (() => void | Promise<void>)[]) => () => void;
    connectStripeAccount(): Promise<void>;
    generateStripeLoginLink(): Promise<string>;
    pause(): Promise<void>;
    resume(): Promise<void>;
};
