import { Service } from "../../../../types/service.js";
import { makeStoreState } from "../state/make-store-state.js";
import { makeStoreAllowance } from "../utils/make-store-allowance.js";
import { makeSubscriptionPlanningService } from "../../api/services/subscription-planning-service.js";
export declare function makeSubscriptionPlanningSubmodel({ state, allowance, subscriptionPlanningService, }: {
    state: ReturnType<typeof makeStoreState>;
    allowance: ReturnType<typeof makeStoreAllowance>;
    subscriptionPlanningService: Service<typeof makeSubscriptionPlanningService>;
}): {
    activate: () => Promise<void>;
    refresh: () => Promise<void>;
    addPlan(options: {
        planLabel: string;
        tierLabel: string;
        tierPrice: number;
    }): Promise<import("../../types/store-concepts.js").SubscriptionPlan>;
};
