import Stripe from "stripe";
export async function stripeAttempt(stripeCall) {
    try {
        const response = await stripeCall();
        return response;
    }
    catch (error) {
        const is404 = (error instanceof Stripe.StripeError &&
            error.statusCode === 404);
        if (is404)
            return undefined;
        else
            throw error;
    }
}
//# sourceMappingURL=stripe-attempt.js.map