import { Stripe } from "stripe";
import { makeStripeLiaison } from "../liaison/stripe-liaison.js";
import { Logger } from "../../../../toolbox/logger/interfaces.js";
import { DatabaseRaw } from "../../../../assembly/backend/types/database.js";
export declare function stripeWebhooks({ logger, stripeLiaison, databaseRaw }: {
    logger: Logger;
    databaseRaw: DatabaseRaw;
    stripeLiaison: ReturnType<typeof makeStripeLiaison>;
}): {
    "checkout.session.completed"(event: Stripe.Event): Promise<void>;
    "invoice.paid"(event: Stripe.Event): Promise<void>;
    "invoice.payment_failed"(event: Stripe.Event): Promise<void>;
    "customer.subscription.updated"(event: Stripe.Event): Promise<void>;
};
