import * as dbmage from "dbmage";
export declare type StoreSchema = dbmage.AsSchema<{
    merchants: {
        stripeAccounts: MerchantRow;
    };
    subscriptions: {
        plans: SubscriptionPlanRow;
        tiers: SubscriptionTierRow;
    };
}>;
export declare type MerchantRow = dbmage.AsRow<{
    time: number;
    userId: dbmage.Id;
    paused: boolean;
    stripeAccountId: string;
}>;
export declare type SubscriptionPlanRow = dbmage.AsRow<{
    label: string;
    planId: dbmage.Id;
    roleId: dbmage.Id;
    time: number;
    stripeAccountId: string;
    stripeProductId: string;
}>;
export declare type SubscriptionTierRow = dbmage.AsRow<{
    label: string;
    tierId: dbmage.Id;
    planId: dbmage.Id;
    roleId: dbmage.Id;
    time: number;
    stripePriceId: string;
    stripeAccountId: string;
}>;
